function [L,U] = iluc(M,d,l,milu)   
% Meaning of the input value
% d droptol
% l fill-in of nnz 
%  

[ n,n ] = size(M);
L = sparse(zeros(n,n));
U = sparse(zeros(n,n));
n_drop=0;
%n_drop2=0;

% Calculate the original norm
if d ~= 0
   for i = 1:n
      norma_row(i) = norm (M(i,:));
      norma_col(i) = norm (M(:,i));
   end
else
   norma_row = zeros(n,1);
   norma_col = zeros(n,1);
end

for k = 1:n
   z (1:k-1) = 0;
   z (k:n) = M(k,k:n);
   for i =1:k-1
      if L(k,i) ~= 0 
         z(k:n) = z(k:n)-L(k,i)*U(i,k:n);
      end 
   end 
   w (1:k) = 0;
   w (k+1:n) = M(k+1:n,k);
   
   for i =1:k-1
      if U(i,k) ~= 0 
         w(k+1:n) = w(k+1:n)-(U(i,k)*L(k+1:n,i))';
      end 
   end
   
   % Apply a dropping rule to row z, k-th row of U
   for i=k+1:n
      if z(i) ~= 0 & abs(z(i)) < d*norma_row(k)
         z(i) = 0;
         n_drop+=1;
      end
   end

   % Apply a dropping rule to column w, k-th column of L  
   for i=k+1:n
      if w(i) ~= 0 & abs(w(i)) < d*norma_col(k)
         w(i) = 0;
         n_drop+=1;
      end
   end

   % level of fill-in
   
   U(k,k)=z(k);
   [ B,IX ] = sort(abs(z(k+1:n)),'descend');
   for ele = 1:min(l,n-k)
      U(k,IX(ele)+k) = z(IX(ele)+k);
   end
    
    if U(k,k) == 0
      error 'There is a pivot equal to zero.'
      return
   end

   w=w/U(k,k);
   [ B,IX ] = sort(abs(w(k+1:n)),'descend');
   for ele = 1:min(l,n-k)
      L(IX(ele)+k,k) = (IX(ele)+k);
   end

   n_drop=n_drop+nnz(w)-nnz(U(k,:))+nnz(z)-nnz(L(:,k));
   L(k,k)=1;
end

L=sparse(L);
U=sparse(U);

n_drop
%n_drop2
return
end
