function [L,U,P] = ilutp2(M,t,d,u,l,milu)   
% Meaning of the input value
% t thresh
% d droptol
% u udiag
% l fill-in of nnz (possible value: 1-5)
% milu 0=off 1=row 2=column
%  
% This function are explained in a Tzu-Yi Chen's pubblication, but there are some change to adapt a ilu documentation find in web.
 
[ n,n ] = size(M);

A = M;
P = sparse(1:n,1:n,1);
permtol = 1:n;
lfil_nnz = l;
space_left = lfil_nnz*nnz(M);
n_drop=0;
%n_drop2=0;

% Calculate the original norm
if d ~= 0
   for i = 1:n
      norma_row(i) = norm (M(i,:));
      norma_col(i) = norm (M(:,i));
   end
else
   norma_row = zeros(n,1);
   norma_col = zeros(n,1);
end

for i = 1:n
   
   % dropping rule in a L part 
   for j = 1:i-1
      if A(i,j) ~= 0
         if abs(A(i,j)) < d*norma_col(permtol(j)) | abs(A(i,j)) < d*norma_row(i)  
           A(i,j) = 0;
           n_drop+=1;
         end
         %if abs(A(i,j))<eps
           % A(i,j)=0;
          %  n_drop2+=1;
          %end
      end
   end

   % determinate if the pivoting is needed
   [value, index] = max(abs(A(i,i+1:n)));
   if t*value > abs(A(i,i)) 
      index = index+i;
      % Apply a pivoting function
      P (:,[i index]) = P (:,[index i]);
      permtol ([i index]) = permtol ([index i]);
      A (:,[i index]) = A (:,[index i]);
   end
   % if remains a pivot null, in input there is a bad matrix
   if A(i,i) == 0
       error 'There is a pivot equal to zero. Consider decreasing the drop tolerance or consider using the udiag option.'
      return
   end

   space_row = space_left/(n-i+1);
   lfil = space_row/2;
   for k = i+1:n
      if A(k,i) ~= 0 & A(i,i) ~= 0
         A(k,i) = A(k,i)/A(i,i);
         % dropping rule for avoid a sum of two row
         if abs(A(k,i))<d*norma_col(permtol(k)) | abs(A(k,i))<d*norma_row(i)
            A(k,i)=0;
            n_drop+=1;
         else
            A(k,i+1:n) = A(k,i+1:n)-A(k,i)*A(i,i+1:n);
         end
      end
   end
  
   % dropping rule in a U part
   for j =i+1:n
      if A(i,j) ~= 0 & (abs(A(i,j)) < d*norma_row(i) | abs(A(i,j)) < d*norma_col(permtol(j)))
        A(i,j)=0;
        n_drop+=1;
      end
      %if abs(A(i,j))<eps
        % A(i,j)=0;
       %  n_drop2+=1;
      %end 
   end
  
   w=A(i,:);
   A(i,:)= zeros(1,n);
   % Sorting element to take the largest value
   [ B,IX ] = sort(abs(w(1:i-1)),'descend');
   for ele = 1:min(lfil,i-1)
      A(i,IX(ele)) = w(IX(ele)); % the largest lfil
   end
   A(i,i) = w(i);
   lfil = space_row-nnz(A(i,1:i-1));
   % Sorting element to take the largest value
   [B,IX] = sort(abs(w(i+1:n)),'descend');
   for ele = 1:min(lfil-1,n-i)
      A(i,IX(ele)+i) = w(IX(ele)+i); % the largest lfil-1
   end
   n_drop=n_drop+nnz(w)-nnz(A(i,:));
   % using udiag value
   if A(i,i) == 0
      A(i,i) = u*norma_row(i); 
   end

   % A diagonal value became null in the procedure
   if A(i,i) == 0
      error 'There is a pivot equal to zero. Consider decreasing the drop tolerance or consider using the udiag option.'
      return
   end
   space_left = space_left-nnz(A(i,:));
end
n_drop
%n_drop2
L = sparse(tril(A,-1))+sparse(eye(n));
U = sparse(triu(A));

return
end
